  /* 
   * Diagramas sintticos
   *
   *                                   +<-----------------------------------+
   *                         T1        !  2                  3              ^
   * T --+---------> ident --o---------+-> * -----+--------> ident ---------+
   *     |                      ^      |       ^  |                         |
   *     +--> ( -> [ E ] -> ) --+      +-> / ->+  +--> ( -> [ E ] -> ) -> --+
   *          4    5        6          |  7            8    9        10
   *                                   +-||            4    
   *                        
   *                        +<---------------------+
   *         1        2     !       3       4      ^
   * E --+-> + --+--->[ T ] --+---> + ----->[ T ] -+
   *     |       ^            |         ^
   *     +-> - ->|            +---> - --+
   *     |   5   |            |     6  
   *     +-------+            +-||
   *                                   
   *                          
   */

//import java.lang.Stack;
import java.util.Stack;

public class Codigos {

  static boolean unario;
  static int     op;
  static Stack   pilha_unario = new Stack(), pilha_op = new Stack();

  // T
  static int num_T = 7; // na verdade tem 10, mas como 8=4, 9=5 e 10=6, usamos apenas 7
  static String [] codigoT = {
            "AC <- pop()\nAC <- - AC\npush(AC)",   // 0
            "AC <- pop()\naux <- pop()", // 4.0    // 1
            "AC <- aux + AC",                      // 2
            "AC <- aux - AC",                      // 3
            "push(AC)"};                           // 4

  private static void empilhaU(boolean b) {
    pilha_unario.push(new Boolean(true)); //
    }
  private static boolean desempilhaU() {
    return ((Boolean)pilha_unario.pop()).booleanValue(); //
    }

  private static void empilhaO(int i) {
    pilha_unario.push(new Integer(i)); //
    }
  private static int desempilhaO() {
    return ((Integer)pilha_op.pop()).intValue(); //
    }

  public static String T1() {
    empilhaU(true); //unario = true;
    return null;
    }
  public static String T2() {
    if (desempilhaU()) {
       return codigoT[0];
       }
    return null;
    }
  public static String T3(char c) {
    if (c=='+') empilhaO(0);//op = 0;
    else empilhaO(1);       //op = 1;
    return null;
    }
  public static String T4() {
    String str = new String(codigoT[1]);
    switch (desempilhaO()) {
      case 0: str += codigoT[2]; break;
      case 1: str += codigoT[3]; break;
      }
    str += codigoT[4];
    return str;    
    }


  }
