/*
 * @author Lenidas de Oliveira Brando
 * @see    Elementos.java; Leia.java; Itens.java
 *
 * MAC323 - 2003
 * Exemplo simples para compilao: expresses aritmticas formadas por {constantes , + , - , * , / }
 *
 * Elemento: "estrutura" para cada item lxico
 * Leia    : para leitura da cadeia de carateres (expresso aritmtica)
 * Itens   : monta os itens lxico num "Vector" (faz o papel de um Analisador Lxico muito simplificado...)
 *
 */

import java.util.StringTokenizer;
import java.util.Vector;

public class Compila {

  String cadeia;   // para a expresso a ser analisada
  Vector itensLex; // para armazenar itens lxicos: seria montado pelo Analisador Lxico (mas aqui vai via StringTockenizer)

  int num_item;    // nmero do item lxico atual

  private int tipo (int i) { // devolve o tipo do item lxico, '0' ou '1'
    return ((Elemento)itensLex.elementAt(i)).tipo();
    }

  private String item (int i) { // devolve o item lxico
    return ((Elemento)itensLex.elementAt(i)).obj();
    }

  private void item () {
    System.out.print(item(num_item)+" ");
    }

  private void avanca_item () {
    item();
    num_item++;
    }

  public static void main(String[] args) {
    Compila comp = new Compila();
    }

  public Compila () {
    cadeia = Leia.readLine(); // como "readLine" no "Leia"  esttico funciona
    //comp.montaItens(comp.cadeia); // se fossem declarados aqui...
    //comp.listaItens();
    itensLex = Itens.montaItens(cadeia); // monta vetor com itens lxicos

    System.out.print("Teste: ");
    Itens.listaItens(itensLex);          // lista itens lxicos, s para conferncia

    num_item = 0; // posiciona para leitura do primeiro item lxico
    //item(); System.out.println("inicio");
    if ( this.E() )  // cadeia  vlida ?
       System.out.println("Cadeia reconhecida");
    else  System.out.println("Cadeia NO reconhecida");
    }

  /* Grafos sintticos (ou diagramas sintticos)
   *
   *                                   +<-----------------------------------+
   *                 1                 !  2                  3              ^
   * T --+---------> ident ------------+-> * -----+--------> ident ---------+
   *     |                      ^      |       ^  |                         |
   *     +--> ( -> [ E ] -> ) --+      +-> / ->+  +--> ( -> [ E ] -> ) -> --+
   *          4    5        6          |  7            8    9        10
   *                                   +-||    
   *                        
   *                        +<---------------------+
   *         1        2     !       3       4      ^
   * E --+-> + --+--->[ T ] --+---> + ----->[ T ] -+
   *     |       ^            |         ^
   *     +-> - ->|            +---> - --+
   *     |   5   |            |     6  
   *     +-------+            +-||
   *
   * Para simplificar a gerao de cdigo  recomendvel anotar no grafo sinttico
   * os pontos de gerao com nmeros. Como fiz no grafo acima com os pontos de 
   * reconhecimento dos itens lxicos (ns terminais e no terminais), anotando-os
   * tambm no cdigo (isso FACILITA MUITO A DEPURAO!!).
   *
   */

  // Os comentrios comenando com "//T" indica o item lxico reconhecido no correspondente grafo de "T"
  boolean Tpar () { // para o diagrama T
    //System.out.println("Tpar");
    if (tipo(num_item)==1 && item(num_item).equals("(")) { // '('
    //T     8 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
       avanca_item();
       if (!E()) {
    	  System.out.println("Erro: esperava um operando aps \'(\' (encontrado \'"+item(num_item)+"\')");
          return false;
          }
    //T     9 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
       if (tipo(num_item)==1 && item(num_item).equals(")")) { // ')'
    //T    10 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
          avanca_item();
          return true;
          }
       else {
          System.out.println("Erro: esperava um \')\' (encontrado \'"+item(num_item)+"\')");
          return false;
          }
       }  // if (tipo(num_item)==1 && item(num_item).equals("("))
    else {
      System.out.println("Erro: esperava um \'(\' ou operando (encontrado \'"+item(num_item)+"\')");
      return false;
      }
    }

  // const,ident: 0
  // operadores : 1
  boolean T () {
    //System.out.println("T num_item="+num_item); 
    try {

    if (tipo(num_item)==0) { //  operando
    //T     1 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
       avanca_item();
       //System.out.println("T : "+item(num_item));
       if (num_item>=itensLex.size()-1) return true;
       }
    else
    if (!Tpar()) {
       System.out.println("Erro: esperado \'(\' ou operando");
       return false;
       }
    // else reconhecido 4, 5, 6
    //T 4 a 6 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
    if (num_item>=itensLex.size()-1) return true;

    while (true) {
      //item(); // para teste
      if (tipo(num_item)==1 && (item(num_item).equals("*")||item(num_item).equals("/")) ) { //  operador
    //T  2, 7 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
         char item_op = item(num_item).charAt(0);
         avanca_item();
         if (tipo(num_item)==0) { //  operando
    //T     3 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
            avanca_item();
            }
         else
         if (!Tpar()) {
            System.out.println("Erro: esperava um operando ou \'(\' aps \'"+item_op+"\' (encontrado \'"+item(num_item)+"\')");
            return false;
           }
    //   else reconhecido 8, 9 e 10 que equivalem a 4, 5 e 6
    //T 4 a 6 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
         if (num_item>=itensLex.size()-1) return true;
         } // no  operando, pode ser ( E )
      else return true;
      } // while
    
    } catch(java.lang.ArrayIndexOutOfBoundsException aobe) {
      System.out.println("T - Erro: final de cadeia");
    }
    return false;
    }

  // Os comentrios comenando com "//E" indica o item lxico reconhecido no correspondente grafo de "E"
  boolean E () {
    //System.out.println("E: "+item(num_item)); //item(); //+itensLex.size()); 
    if (tipo(num_item)==1 && (item(num_item).equals("+")||item(num_item).equals("-"))) { //  operador unrio
    //E  1, 5 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
       if (num_item>=itensLex.size()-1) {
	  System.out.println("Erro: final de cadeia aps um operador unrio (\'+\' ou \'-\'), esperava operando");
          return false;
          }
       avanca_item();
       }
    if (!T()) {
       System.out.println("Erro: esperava um operando (encontrado \'"+item(num_item)+"\')");
       return false;
       }
    else { // reconhecido T
    //E     2 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
       //System.out.println("E: "+item(num_item+1));
       if (num_item>=itensLex.size()-1) {
          return true;
          }
       //avanca_item();
       }

    try {
    while (true) {
      //System.out.print("|E: "+item(num_item)+"|"); //item(); 
      if (tipo(num_item)==1 && (item(num_item).equals("+")||item(num_item).equals("-"))) { //  operador
    //E  3, 6 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
         avanca_item();
         if (!T()) {  // esperava um T
	    System.out.println("Erro: esperava um operando (encontrado \'"+item(num_item)+"\')");
            return false;
            }
         else {
    //E     4 --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- 
	    if (num_item>=itensLex.size()-1) return true;
            avanca_item();
	    }
         } // if // reconhecido (+|-) T
      else
      //if (num_item>=itensLex.size()-1)
         return true;
      //else return false;
      } // while
    } catch(java.lang.ArrayIndexOutOfBoundsException aobe) {
      System.out.println("\nE - Erro: final de cadeia");
      return false;
    }
    //return true;
    }

  }
